org.apache.commons.math3.distribution

## Class WeibullDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.WeibullDistribution

- All Implemented Interfaces:
    Serializable, RealDistribution

      public class WeibullDistribution
      extends AbstractRealDistribution

  Implementation of the Weibull distribution. This implementation uses the two parameter form of the distribution defined by Weibull Distribution, equations (1) and (2).
  Since:
    1.1 (changed to concrete class in 3.0)
  Version:
    $Id: WeibullDistribution.java 1244107 2012-02-14 16:17:55Z erans $
  See Also:
    Weibull distribution (Wikipedia), Weibull distribution (MathWorld), Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WeibullDistribution(double alpha, double beta)` Create a Weibull distribution with the given shape and scale and a location equal to zero.
    `WeibullDistribution(double alpha, double beta, double inverseCumAccuracy)` Create a Weibull distribution with the given shape, scale and inverse cumulative probability accuracy and a location equal to zero.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double` | `calculateNumericalMean()` used by `getNumericalMean()`
    `protected double` | `calculateNumericalVariance()` used by `getNumericalVariance()`
    `double` | `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `double` | `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `double` | `getScale()` Access the scale parameter, `beta`.
    `double` | `getShape()` Access the shape parameter, `alpha`.
    `protected double` | `getSolverAbsoluteAccuracy()` Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
    `double` | `getSupportLowerBound()` Access the lower bound of the support.
    `double` | `getSupportUpperBound()` Access the upper bound of the support.
    `double` | `inverseCumulativeProbability(double p)` Computes the quantile function of this distribution.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `boolean` | `isSupportLowerBoundInclusive()` Use this method to get information about whether the lower bound of the support is inclusive or not.
    `boolean` | `isSupportUpperBoundInclusive()` Use this method to get information about whether the upper bound of the support is inclusive or not.
    `double` | `probability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `cumulativeProbability, reseedRandomGenerator, sample, sample`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

          public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

      Default inverse cumulative probability accuracy.
      Since:
        2.1
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### WeibullDistribution

          public WeibullDistribution(double alpha,
                             double beta)
                              throws NotStrictlyPositiveException

      Create a Weibull distribution with the given shape and scale and a location equal to zero.
      Parameters:
        `alpha` - Shape parameter.
        `beta` - Scale parameter.
      Throws:
        `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.

    - #### WeibullDistribution

          public WeibullDistribution(double alpha,
                             double beta,
                             double inverseCumAccuracy)
                              throws NotStrictlyPositiveException

      Create a Weibull distribution with the given shape, scale and inverse cumulative probability accuracy and a location equal to zero.
      Parameters:
        `alpha` - Shape parameter.
        `beta` - Scale parameter.
        `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
      Throws:
        `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.
      Since:
        2.1

  - ### Method Detail

    - #### getShape

          public double getShape()

      Access the shape parameter, `alpha`.
      Returns:
        the shape parameter, `alpha`.

    - #### getScale

          public double getScale()

      Access the scale parameter, `beta`.
      Returns:
        the scale parameter, `beta`.

    - #### probability

          public double probability(double x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution. For this distribution `P(X = x)` always evaluates to 0.
      Parameters:
        `x` - the point at which the PMF is evaluated
      Returns:
        0

    - #### density

          public double density(double x)

      Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.
      Parameters:
        `x` - the point at which the PDF is evaluated
      Returns:
        the value of the probability density function at point `x`

    - #### cumulativeProbability

          public double cumulativeProbability(double x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### inverseCumulativeProbability

          public double inverseCumulativeProbability(double p)

      Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is
      - `inf{x in R | P(X<=x) >= p}` for `0 < p <= 1`,
      - `inf{x in R | P(X<=x) > 0}` for `p = 0`.
      The default implementation returns
      - `RealDistribution.getSupportLowerBound()` for `p = 0`,
      - `RealDistribution.getSupportUpperBound()` for `p = 1`.
      Returns `0` when `p == 0` and `Double.POSITIVE_INFINITY` when `p == 1`.
      Specified by:
        `inverseCumulativeProbability` in interface `RealDistribution`
      Overrides:
        `inverseCumulativeProbability` in class `AbstractRealDistribution`
      Parameters:
        `p` - the cumulative probability
      Returns:
        the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)

    - #### getSolverAbsoluteAccuracy

          protected double getSolverAbsoluteAccuracy()

      Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
      Overrides:
        `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
      Returns:
        the solver absolute accuracy.
      Since:
        2.1

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. The mean is `scale * Gamma(1 + (1 / shape))`, where `Gamma()` is the Gamma-function.
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### calculateNumericalMean

          protected double calculateNumericalMean()

      used by `getNumericalMean()`
      Returns:
        the mean of this distribution

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. The variance is `scale^2 * Gamma(1 + (2 / shape)) - mean^2` where `Gamma()` is the Gamma-function.
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

    - #### calculateNumericalVariance

          protected double calculateNumericalVariance()

      used by `getNumericalVariance()`
      Returns:
        the variance of this distribution

    - #### getSupportLowerBound

          public double getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in R | P(X <= x) > 0}`.

      The lower bound of the support is always 0 no matter the parameters.
      Returns:
        lower bound of the support (always 0)

    - #### getSupportUpperBound

          public double getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is always positive infinity no matter the parameters.
      Returns:
        upper bound of the support (always `Double.POSITIVE_INFINITY`)

    - #### isSupportLowerBoundInclusive

          public boolean isSupportLowerBoundInclusive()

      Use this method to get information about whether the lower bound of the support is inclusive or not.
      Returns:
        whether the lower bound of the support is inclusive or not

    - #### isSupportUpperBoundInclusive

          public boolean isSupportUpperBoundInclusive()

      Use this method to get information about whether the upper bound of the support is inclusive or not.
      Returns:
        whether the upper bound of the support is inclusive or not

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.